library(stockassessment)

## Clean results
setwd("res")
unlink(list.files("."))

setwd("../run")
load("data.RData")
conf<-loadConf(dat,"../conf/model.cfg", patch=TRUE)
par<-defpar(dat,conf)
par$logSdLogFsta<-0
fit<-sam.fit(dat,conf,par, rel.tol = 1e-8, 	upper=list(itrans_rho = 5))
if(fit$opt$convergence!=0) stop("Model did not converge.")
save(fit, file="model.RData")
cat("Version:",attr(fit,"Version"),"\n", file="ver")
cat("RemoteSha:", attr(fit,"RemoteSha"),"\n", file="ver", append=TRUE)
